<template>
  <div>
    <template v-if="treeData.length">
      <Arbol
        ref="arbol"
        v-model="vmodel"
        :node="treeData"
        :disabled="disabled"
        parent="root"
      />
    </template>
  </div>
</template>
<script>
import store from "@/store";
import Arbol from "@/views/secure/modelo-negocio/documentos/visualizador/folios/etiqueta-arbol/components/Arbol.vue";
const axios = store.state.axiosApiLocal;
export default {
  name: "Component-DirectorioArbol",
  props: {
    value: null,
    disabled: {
      type: Boolean,
      required: false,
    },
  },
  components: {
    Arbol,
  },
  data() {
    return {
      treeData: [],
      vmodel: null,
    };
  },
  watch: {
    vmodel(val) {
      this.$emit("input", val);
    },
  },
  methods: {
    clear() {
      if (this.$refs.arbol) {
        this.$refs.arbol.clear();
      }
    },
    getNiveles() {
      var self = this;
      axios("/modelo-negocio/arbol-negocio/v1/")
        .then((response) => {
          let data = response.data;
          if (data) {
            let arboles = data.resultado.arboles;
            if (arboles) {
              let treeData = self.generateTree(arboles);
              self.treeData = treeData.children;
            }
          }
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        });
    },
    generateTree(list) {
      let treeTemp = (function(data, root) {
        var r,
          o = {};
        data.forEach(function(a) {
          a.children = o[a.idArbol] && o[a.idArbol].children;
          o[a.idArbol] = a;
          if (a.idModeloNegocioPadre === root) {
            r = a;
          } else {
            o[a.idModeloNegocioPadre] = o[a.idModeloNegocioPadre] || {};
            o[a.idModeloNegocioPadre].children =
              o[a.idModeloNegocioPadre].children || [];
            if (a.idModeloNegocioPadre !== 0 && a.idModeloNegocioPadre !== 1) {
              a.parentNode = data.filter(
                (element) => element.idArbol == a.idModeloNegocioPadre
              )[0];
            }
            o[a.idModeloNegocioPadre].children.push(a);
          }
        });
        return r;
      })(list, 0);
      return treeTemp.length === 1 ? treeTemp[0] : treeTemp; //Si solo hay un padre, se envía solo ese objeto en lugar del arreglo completo.
    },
  },
  created() {
    this.getNiveles();
  },
};
</script>
